### Method

# Camel CipherContext sign_sync

since: 3.0

#### Declaration [src]

    gboolean
    camel_cipher_context_sign_sync (
      CamelCipherContext* context,
      const gchar* userid,
      CamelCipherHash hash,
      CamelMimePart* ipart,
      CamelMimePart* opart,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Converts the (unsigned) part `ipart` into a new self-contained MIME part `opart`. This may be a multipart/signed part, or a simple part for enveloped types.

Available since: 3.0

#### Parameters

`userid`

  Type: `const gchar*`

  A private key to use to sign the stream.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`hash`

  Type: `CamelCipherHash`

  Preferred Message-Integrity-Check hash algorithm.

`ipart`

  Type: `CamelMimePart`

  Input `CamelMimePart`.

  The data is owned by the caller of the method.

`opart`

  Type: `CamelMimePart`

  Output `CamelMimePart`.

  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` on error.